Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Runtime.InteropServices
Imports System.Threading

Namespace TestHarness

  Public Class Form1
      Inherits Form
        <DllImport("user32.dll", EntryPoint:="FindWindow", CharSet:=CharSet.Auto)>
        Shared Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
        End Function

        <DllImport("user32.dll", EntryPoint:="FindWindowEx", CharSet:=CharSet.Auto)>
        Shared Function FindWindowEx(ByVal hwndParent As IntPtr, ByVal hwndChildAfter As IntPtr, ByVal lpszClass As String, ByVal lpszWindow As String) As IntPtr
        End Function

        <DllImport("user32.dll", EntryPoint:="PostMessage", CharSet:=CharSet.Auto)>
        Shared Function PostMessage1(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As Integer, ByVal lParam As Integer) As Boolean
        End Function

        Private wb As System.Windows.Forms.WebBrowser = Nothing
        Private button1 As Button = Nothing
        Private listBox1 As ListBox = Nothing

        Public Sub New()
            ' button1
            button1 = New Button()
            button1.Location = New Point(20, 430)
            button1.Size = New Size(90, 23)
            button1.Text = "Load and Test"
            AddHandler button1.Click, AddressOf button1_Click

            ' listBox1
            listBox1 = New ListBox()
            listBox1.Location = New Point(10, 460)
            listBox1.Size = New Size(460, 200)

            ' wb
            wb = New WebBrowser()
            wb.Location = New Point(10, 10)
            wb.Size = New Size(460, 400)
            AddHandler wb.DocumentCompleted, AddressOf ExerciseApp

            ' Form1
            Me.Text = "Lightweight Web Application WinForm Test Harness"
            Me.Size = New Size(500, 710)
            Me.Controls.Add(wb)
            Me.Controls.Add(button1)
            Me.Controls.Add(listBox1)
        End Sub ' Form1()

        Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) ' run test automation
            listBox1.Items.Add("Loading Web app under test into WebBrowser control")
            wb.Url = New Uri("http://localhost/ColorApp/default.html")
        End Sub

        Private Sub ExerciseApp(ByVal sender As Object, ByVal e As EventArgs)
            Dim thread As New Thread(New ThreadStart(AddressOf WatchForAndClickAwayMessageBox))
            thread.Start()

            listBox1.Items.Add("Clicking on 'Click Me' button")
            Dim btn1 As HtmlElement = wb.Document.GetElementById("button1")
            btn1.InvokeMember("click")

            listBox1.Items.Add("Waiting to click away message box")

            listBox1.Items.Add("'Typing' roses into TextBox1")
            Dim tb1 As HtmlElement = wb.Document.GetElementById("TextBox1")
            tb1.InnerText = "roses"

            listBox1.Items.Add("Clicking on 'Click Me' button again")
            btn1 = wb.Document.GetElementById("button1")
            btn1.InvokeMember("click")

            'System.Threading.Thread.Sleep(1500) ' ineffective!
            listBox1.Items.Add("Looking for 'red' in TextBox2")
            Dim tb2 As HtmlElement = wb.Document.GetElementById("TextBox2")
            Dim response As String = tb2.OuterHtml
            If response.IndexOf("red") >= 0 Then
                listBox1.Items.Add("Found 'red' in TextBox2")
                listBox1.Items.Add("Test scenario result: PASS")
            Else
                listBox1.Items.Add("Did NOT find 'red' in TextBox2")
                listBox1.Items.Add("Test scenario result: **FAIL**")
            End If


        End Sub

        Private Sub WatchForAndClickAwayMessageBox()
            Dim hMessBox As IntPtr = IntPtr.Zero
            Dim mbFound As Boolean = False
            Dim attempts As Integer = 0
            Dim caption As String = "Message from webpage"
            Do
                hMessBox = FindWindow(Nothing, caption)
                If hMessBox = IntPtr.Zero Then
                    listBox1.Items.Add("Watching for message box . . . ")
                    System.Threading.Thread.Sleep(100)
                    attempts += 1
                Else
                    listBox1.Items.Add("Message box has been found")
                    mbFound = True
                End If
            Loop While (Not mbFound) AndAlso attempts < 250

            If Not mbFound Then
                listBox1.Items.Add("Did not find message box")
                listBox1.Items.Add("Test scenario result: **FAIL**")
            Else
                Dim hOkBtn As IntPtr = FindWindowEx(hMessBox, IntPtr.Zero, Nothing, "OK")
                ClickOn(hOkBtn)
            End If

        End Sub

        Private Sub ClickOn(ByVal hControl As IntPtr)
            Dim WM_LBUTTONDOWN As UInteger = &H201
            Dim WM_LBUTTONUP As UInteger = &H202
            PostMessage1(hControl, WM_LBUTTONDOWN, 0, 0)
            PostMessage1(hControl, WM_LBUTTONUP, 0, 0)
        End Sub

        <STAThread()>
        Private Shared Sub Main()
            Application.Run(New Form1())
        End Sub
    End Class ' class Form1
End Namespace ' ns